<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;

class ImportacaoCatracaController extends \Teknisa\MAN\Controllers\TeknisaCrud {
    protected $importacaoServices;
    
    public function __construct(Services\ImportacaoCatracaServices $importacaoServices) {
        $this->importacaoServices = $importacaoServices;
    }
    
    public function findFilial(DTO\Request\Filter $request, DTO\Response $response){
        $conditions = $request->getFilterCriteria()->getConditions();
        
        if(isset($conditions) && isset($conditions[0]) && $conditions[0]['columnName'] == 'CDFILIAL'){
            $CDFILIAL = $conditions[0]['value'];
        }else{
            $CDFILIAL = NULL;
        }
        
        if(isset($conditions) && isset($conditions[1]) && $conditions[1]['columnName'] == 'DTIMPORT'){
            $DT = $conditions[1]['value'];
            if(isset($DT[0])){
                $DTINI = $DT[0];
            }else{
                $DTINI = NULL;
            }
            
            if(isset($DT[1])){
                $DTFIN = $DT[1];
            }else{
                $DTFIN = NULL;
            }
        }
        
        if(isset($conditions) && isset($conditions[2]) && $conditions[2]['columnName'] == 'TPCRITICA'){
            $TPCRITICA = $conditions[2]['value'];
        }else{
            $TPCRITICA = NULL;
        }

        $conditions = [
            'IDCRALOGCAT'   =>  NULL,
            'IDCATLOGCAT'   =>  NULL,
            'IDDATLOGCAT'   =>  NULL,
            'IDSERLOGCAT'   =>  NULL,
            'IDDUPLOGCAT'   =>  NULL,
            'IDCRAHABFILI'  =>  NULL,
            'IDPROLOGCAT'   =>  NULL
        ];
        
       $count = sizeof($TPCRITICA);
       
       if($count == 7){
           $conditions['TODOS'] = 'T';
       }else{
           foreach($TPCRITICA as $key => $value){
               $exists = array_key_exists($value, $conditions);
               if($exists){
                   $conditions[$value] = 3;
               }
           }
           $conditions['TODOS'] = NULL;
       }
        
        $conditions['CDFILIAL'] = $CDFILIAL;
        $conditions['DTINI'] = $DTINI;
        $conditions['DTFIN'] = $DTFIN;
        
        $query = $this->importacaoServices->findFilial($conditions);
        
        $response->addDataSet(new DataSet('findLogs', $query));
    }
    
    public function uploadDadosCatraca(DTO\Request\DataSet $request, DTO\Response $response){
        $params = array();

        $rows = $request->getDataSet()->getRows()[0];
        $base64 = explode(",", $rows['ARQEXCEL'][0]['b64File']);
        $data = base64_decode($base64[1]);
        $dataArray = explode(PHP_EOL, $data);

        $NRSEQARQIMP = 0; //SIZE = 10
        $params['NMARQLOGCAT'] = $rows['ARQEXCEL'][0]['name']; //ARQUIVO
        $params['CDOPERADOR'] = $rows['CDOPERADOR']; //NOME OPERADOR
        $params['CDFILIAL'] = $rows['CDFILIAL']; //NOME OPERADOR

        foreach($dataArray as $data => $line){

            if(!empty($line)){
            
                $info = explode(';', $line);
                ++$NRSEQARQIMP;

                try{
                    $params['NRSEQARQIMP'] = $NRSEQARQIMP;
                    $params['CDCAIXLOGCAT'] = $info[0];
                    $params['NRIDENLOGCAT'] = $info[1];
                    $params['NRIDENLOGCAT'] = $info[2];
                    $params['NMOPERADOR'] = $info[3];
                    
                    $params['DSOBSLOGCAT'] = $params['CDCAIXLOGCAT']. ' - ' .$params['NRIDENLOGCAT']. ' - ' .$params['NMOPERADOR'];
                }catch (\Exception $e){
                    throw $e;
                }
                
                // DTIMPLOGCAT - COLOCAR SYSDATE NESSE CARA
                // OS CAMPOS ABAIXO, VOU DEIXAR LISTADOS COMO '1' ATÉ ENTENDER O QUE ROLA
                //$params['IDPROLOGCAT'] = 1; //PRODUTO
                $params['IDSERLOGCAT'] = '1'; //SERVIÇO
                $params['IDCRAHABFILI'] = '1'; //HABILITADO PARA FILIAL
                $params['IDDUPLOGCAT'] = '1'; //CRACHÁ DUPLICADO
                $params['IDCATLOGCAT'] = '1'; //CATRACA
                $params['IDCRALOGCAT'] = '1'; //CRACHA
                
                print_r($params);
            }
        }
        die;
                

        /*
        $row = $request->getDataSet()->getRows();
        $file = $row[0]['ARQEXCEL'][0]['b64File'];
        $teste = base64_decode($file);
        print_r($teste);die;
        
        $fileContent = file_get_contents($file);
        var_dump($fileContent);
        */
    }
    
    public function deleteRowLogCatraca(DTO\Request\DataSet $request, DTO\Response $response){
        var_dump($request);
    }
}
