<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO\Request;
use \Zeedhi\Framework\DTO\Request\Filter;
use \Zeedhi\Framework\DTO\Response;
use Teknisa\MAN\Services;
//use \Zeedhi\Framework\DataSource\DataSet;

class Login extends \Zeedhi\Framework\Controller\Simple {

	protected $loginService;

    public function __construct(Services\Login $loginService) {
        $this->loginService = $loginService;
    }

	public function autenticar( $request, $response) {

		try {
//@todo mudar para request do tipo row ao invés de uma do tipo filter.
			$credenciais = $request->getFilterCriteria()->getConditions();
            $email = $credenciais[0]['value'];
            $senha = $credenciais[1]['value'];
            $dadosDaSessao = $this->loginService->autenticar($email, $senha);
            // $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet ('unidades', $unidades));
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet ('operador', $dadosDaSessao));
		} catch(\Exception $e) {
			$response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function sair(Request $request, Response $response){
        try {
            $this->loginService->sair();
            $response->setDataSets(array());
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function retornaVersaoServer($request, $response){
        try {
            $arquivoVersao = $this->loginService->pegaArquivoVersao();
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet ('version', $arquivoVersao));
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function autoLogin(Request\Row $request, $response){
        $cdoperador = $request->getRow()['cdoperador'];
        $senhacryp = $request->getRow()['senha'];
        try {
            $dados = $this->loginService->habilitaLogin($cdoperador, $senhacryp);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet ('findOperadorByCdoperador', $dados));
        } catch (\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

}