<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Notification;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services;

class TabelPrecoModulesController extends CrudWithParameterBag {

    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService, $tabelPrecoModulesService) {
        $this->Manager = $dataSourceManager;
        $this->ParameterBag = $parameterBag;
        $this->utilService = $utilService;
        $this->tabelPrecoModulesService = $tabelPrecoModulesService;
    }
    
    public function copiaPrecoDif(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $conditions = $this->utilService->getParamsAsArray($request);
            $this->tabelPrecoModulesService->copiaPrecoDif($conditions);
            $response->addMessage(new Message('Alterações realizadas.'));
        } catch (\Exception $e) {
            
            if((strpos($e->getMessage(), 'ORA-00001') != false)) {
                $response->addMessage(new Message(1));
            } else {
                $response->addMessage(new Message(0));
            }
            
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function alt_autom(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $conditions = $this->utilService->getParamsAsArray($request);
            $this->tabelPrecoModulesService->alt_autom($conditions);
            $response->addMessage(new Message('Alterações realizadas.'));
        } catch (\Exception $e) {
            
            if((strpos($e->getMessage(), 'ORA-00001') != false)) {
                $response->addMessage(new Message(1));
            } else {
                $response->addMessage(new Message(0));
            }
            
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
}    